=== modified file 'NEWS'
--- NEWS	2005-08-22 16:31:16 +0000
+++ NEWS	2005-08-22 17:52:11 +0000
@@ -6,6 +6,12 @@
       help with intelligent shell completion.
 
 
+  BUG FIXES:
+
+    * ``bzr upgrade`` no longer fails when trying to fix trees that
+      mention revisions that are not present.
+
+
 bzr-0.0.6 2005-08-18
 
   NEW FEATURES:

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2005-06-28 05:33:40 +0000
+++ bzrlib/upgrade.py	2005-08-22 17:52:11 +0000
@@ -15,7 +15,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-
+import bzrlib.errors
 
 
 def upgrade(branch):
@@ -71,17 +71,20 @@
                 mutter("  set inventory_sha1 on {%s}" % rev_id)
 
             for prr in rev.parents:
-                actual_sha1 = branch.get_revision_sha1(prr.revision_id)
-                if (updated_previous_revision
-                    or prr.revision_sha1 is None):
-                    if prr.revision_sha1 != actual_sha1:
-                        prr.revision_sha1 = actual_sha1
-                        updated = True
-                elif actual_sha1 != prr.revision_sha1:
-                    raise BzrCheckError("parent {%s} of {%s} sha1 mismatch: "
-                                        "%s vs %s"
-                                        % (prr.revision_id, rev_id,
-                                           actual_sha1, prr.revision_sha1))
+                try:
+                    actual_sha1 = branch.get_revision_sha1(prr.revision_id)
+                except bzrlib.errors.NoSuchRevision:
+                    mutter("parent {%s} of {%s} not present in branch; skipped"
+                           % (prr.revision_id, rev_id))
+                    continue
+                    
+                if actual_sha1 != prr.revision_sha1:
+                    mutter("parent {%s} of {%s} sha1 mismatch: "
+                           "%s vs %s; fixed"
+                           % (prr.revision_id, rev_id,
+                              actual_sha1, prr.revision_sha1))
+                    prr.revision_sha1 = actual_sha1
+                    updated = True
 
             if updated:
                 updated_previous_revision = True

